<template>
	<div>
		<div ref="loginPopup" id="loginPopup" class="login-popup">
			<button class="button button--close-login" @click="hideLoginPopup"></button>
			<form v-on:submit.prevent>
				<div>
					<div>E-Mail</div>
					<input ref="email" v-model="form.email" class="input" name="email" type="email" autocomplete="email" />
				</div>
				<div>
					<div>Password</div>
					<input ref="password" v-model="form.password" class="input" name="password" type="password" autocomplete="current-password" />
				</div>
				<div>
					<router-link to="/register" @click.native="hideLoginPopup" class="button button--mobile-stretch button--light">New User</router-link>
					<button class="button button--mobile-stretch button--light" @click="performLogin">Login</button>
				</div>
			</form>
		</div>
		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</div>
</template>

<script>
import systemMessage from "@/components/SystemMessage";

export default {
	name: "LoginPopup",
	components: { systemMessage },
	data: () => ({
		form: {
			email: "",
			password: ""
		},
		sysMsg: undefined
	}),
	methods: {
		async performLogin() {
			this.sysMsg = "";
			let verified = this.globalValidateForm();

			if (!verified) {
				this.sysMsg = "Fehlende Eingaben!";
				return;
			}
			try {
				const response = await this.$http.post("/api/login", this.form);
				let jwt = response.data.jwt;
				if (jwt) {
					await this.$store.dispatch("login", { jwt });
					if (this.$route.path !== "/home") {
						await this.$router.push("/home");
					}
				}
			} catch (e) {
				switch (e.response.status) {
					case 404:
						this.sysMsg = "User nicht gefunden!";
						this.$refs.email.focus();
						this.$refs.email.classList.add("input--alert");
						break;
					case 403:
						this.sysMsg = "Falsches Passwort!";
						this.$refs.password.focus();
						this.$refs.password.classList.add("input--alert");

				}
			}
		},

		hideLoginPopup() {
			this.$refs.loginPopup.classList.remove("login-popup--show");
			this.globalResetFormValidation();
		}
	}
}
</script>

<style scoped>

</style>